"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.PostgresClient = exports.PostgresClientConnection = exports.TypeResolver = exports.ConnectionReservation = exports.PostgresConnectionPool = exports.PostgresStats = exports.FindCommand = exports.DebugSelectCommand = exports.InsertCommand = exports.SimpleQueryCommand = exports.Command = exports.PostgresDatabaseTransaction = exports.ConnectionStatus = exports.ResponseParser = exports.readMessageSize = exports.PostgresConnectionError = exports.PostgresError = exports.CommonTypes = void 0;
/*@ts-ignore*/
const { __ΩReceiveType } = require('@deepkit/type');
/** @reflection never */
const net_1 = require("net");
const core_1 = require("@deepkit/core");
const orm_1 = require("@deepkit/orm");
const type_1 = require("@deepkit/type");
const tls_1 = require("tls");
const config_js_1 = require("./config.js");
var CommonTypes;
(function (CommonTypes) {
    CommonTypes[CommonTypes["bool"] = 16] = "bool";
    CommonTypes[CommonTypes["bytea"] = 17] = "bytea";
    CommonTypes[CommonTypes["char"] = 18] = "char";
    CommonTypes[CommonTypes["name"] = 19] = "name";
    CommonTypes[CommonTypes["int8"] = 20] = "int8";
    CommonTypes[CommonTypes["int2"] = 21] = "int2";
    CommonTypes[CommonTypes["int2vector"] = 22] = "int2vector";
    CommonTypes[CommonTypes["int4"] = 23] = "int4";
    CommonTypes[CommonTypes["regproc"] = 24] = "regproc";
    CommonTypes[CommonTypes["text"] = 25] = "text";
    CommonTypes[CommonTypes["oid"] = 26] = "oid";
    CommonTypes[CommonTypes["tid"] = 27] = "tid";
    CommonTypes[CommonTypes["xid"] = 28] = "xid";
    CommonTypes[CommonTypes["cid"] = 29] = "cid";
    CommonTypes[CommonTypes["oidvector"] = 30] = "oidvector";
    CommonTypes[CommonTypes["json"] = 114] = "json";
    CommonTypes[CommonTypes["xml"] = 142] = "xml";
    CommonTypes[CommonTypes["_xml"] = 143] = "_xml";
    CommonTypes[CommonTypes["pg_node_tree"] = 194] = "pg_node_tree";
    CommonTypes[CommonTypes["_json"] = 199] = "_json";
    CommonTypes[CommonTypes["_xid8"] = 271] = "_xid8";
    CommonTypes[CommonTypes["point"] = 600] = "point";
    CommonTypes[CommonTypes["lseg"] = 601] = "lseg";
    CommonTypes[CommonTypes["path"] = 602] = "path";
    CommonTypes[CommonTypes["box"] = 603] = "box";
    CommonTypes[CommonTypes["polygon"] = 604] = "polygon";
    CommonTypes[CommonTypes["line"] = 628] = "line";
    CommonTypes[CommonTypes["_line"] = 629] = "_line";
    CommonTypes[CommonTypes["cidr"] = 650] = "cidr";
    CommonTypes[CommonTypes["_cidr"] = 651] = "_cidr";
    CommonTypes[CommonTypes["float4"] = 700] = "float4";
    CommonTypes[CommonTypes["float8"] = 701] = "float8";
    CommonTypes[CommonTypes["unknown"] = 705] = "unknown";
    CommonTypes[CommonTypes["circle"] = 718] = "circle";
    CommonTypes[CommonTypes["_circle"] = 719] = "_circle";
    CommonTypes[CommonTypes["money"] = 790] = "money";
    CommonTypes[CommonTypes["_money"] = 791] = "_money";
    CommonTypes[CommonTypes["macaddr"] = 829] = "macaddr";
    CommonTypes[CommonTypes["inet"] = 869] = "inet";
    CommonTypes[CommonTypes["_bool"] = 1000] = "_bool";
    CommonTypes[CommonTypes["_bytea"] = 1001] = "_bytea";
    CommonTypes[CommonTypes["_char"] = 1002] = "_char";
    CommonTypes[CommonTypes["_name"] = 1003] = "_name";
    CommonTypes[CommonTypes["_int2"] = 1005] = "_int2";
    CommonTypes[CommonTypes["_int2vector"] = 1006] = "_int2vector";
    CommonTypes[CommonTypes["_int4"] = 1007] = "_int4";
    CommonTypes[CommonTypes["_regproc"] = 1008] = "_regproc";
    CommonTypes[CommonTypes["_text"] = 1009] = "_text";
    CommonTypes[CommonTypes["_tid"] = 1010] = "_tid";
    CommonTypes[CommonTypes["_xid"] = 1011] = "_xid";
    CommonTypes[CommonTypes["_cid"] = 1012] = "_cid";
    CommonTypes[CommonTypes["_oidvector"] = 1013] = "_oidvector";
    CommonTypes[CommonTypes["_bpchar"] = 1014] = "_bpchar";
    CommonTypes[CommonTypes["_varchar"] = 1015] = "_varchar";
    CommonTypes[CommonTypes["_int8"] = 1016] = "_int8";
    CommonTypes[CommonTypes["_point"] = 1017] = "_point";
    CommonTypes[CommonTypes["_lseg"] = 1018] = "_lseg";
    CommonTypes[CommonTypes["_path"] = 1019] = "_path";
    CommonTypes[CommonTypes["_box"] = 1020] = "_box";
    CommonTypes[CommonTypes["_float4"] = 1021] = "_float4";
    CommonTypes[CommonTypes["_float8"] = 1022] = "_float8";
    CommonTypes[CommonTypes["_polygon"] = 1027] = "_polygon";
    CommonTypes[CommonTypes["_oid"] = 1028] = "_oid";
    CommonTypes[CommonTypes["aclitem"] = 1033] = "aclitem";
    CommonTypes[CommonTypes["_aclitem"] = 1034] = "_aclitem";
    CommonTypes[CommonTypes["_macaddr"] = 1040] = "_macaddr";
    CommonTypes[CommonTypes["_inet"] = 1041] = "_inet";
    CommonTypes[CommonTypes["bpchar"] = 1042] = "bpchar";
    CommonTypes[CommonTypes["varchar"] = 1043] = "varchar";
    CommonTypes[CommonTypes["date"] = 1082] = "date";
    CommonTypes[CommonTypes["time"] = 1083] = "time";
    CommonTypes[CommonTypes["timestamp"] = 1114] = "timestamp";
    CommonTypes[CommonTypes["_timestamp"] = 1115] = "_timestamp";
    CommonTypes[CommonTypes["_date"] = 1182] = "_date";
    CommonTypes[CommonTypes["_time"] = 1183] = "_time";
    CommonTypes[CommonTypes["timestamptz"] = 1184] = "timestamptz";
    CommonTypes[CommonTypes["_timestamptz"] = 1185] = "_timestamptz";
    CommonTypes[CommonTypes["interval"] = 1186] = "interval";
    CommonTypes[CommonTypes["_interval"] = 1187] = "_interval";
    CommonTypes[CommonTypes["_numeric"] = 1231] = "_numeric";
    CommonTypes[CommonTypes["_cstring"] = 1263] = "_cstring";
    CommonTypes[CommonTypes["timetz"] = 1266] = "timetz";
    CommonTypes[CommonTypes["_timetz"] = 1270] = "_timetz";
    CommonTypes[CommonTypes["bit"] = 1560] = "bit";
    CommonTypes[CommonTypes["_bit"] = 1561] = "_bit";
    CommonTypes[CommonTypes["varbit"] = 1562] = "varbit";
    CommonTypes[CommonTypes["_varbit"] = 1563] = "_varbit";
    CommonTypes[CommonTypes["numeric"] = 1700] = "numeric";
    CommonTypes[CommonTypes["record"] = 2249] = "record";
    CommonTypes[CommonTypes["cstring"] = 2275] = "cstring";
    CommonTypes[CommonTypes["any"] = 2276] = "any";
    CommonTypes[CommonTypes["anyarray"] = 2277] = "anyarray";
    CommonTypes[CommonTypes["void"] = 2278] = "void";
    CommonTypes[CommonTypes["trigger"] = 2279] = "trigger";
    CommonTypes[CommonTypes["language_handler"] = 2280] = "language_handler";
    CommonTypes[CommonTypes["internal"] = 2281] = "internal";
    CommonTypes[CommonTypes["anyelement"] = 2283] = "anyelement";
    CommonTypes[CommonTypes["_record"] = 2287] = "_record";
    CommonTypes[CommonTypes["anynonarray"] = 2776] = "anynonarray";
    CommonTypes[CommonTypes["pg_authid"] = 2842] = "pg_authid";
    CommonTypes[CommonTypes["pg_auth_members"] = 2843] = "pg_auth_members";
    CommonTypes[CommonTypes["_txid_snapshot"] = 2949] = "_txid_snapshot";
    CommonTypes[CommonTypes["uuid"] = 2950] = "uuid";
    CommonTypes[CommonTypes["_uuid"] = 2951] = "_uuid";
    CommonTypes[CommonTypes["txid_snapshot"] = 2970] = "txid_snapshot";
    CommonTypes[CommonTypes["fdw_handler"] = 3115] = "fdw_handler";
    CommonTypes[CommonTypes["tsm_handler"] = 3310] = "tsm_handler";
    CommonTypes[CommonTypes["pg_ndistinct"] = 3361] = "pg_ndistinct";
    CommonTypes[CommonTypes["pg_dependencies"] = 3402] = "pg_dependencies";
    CommonTypes[CommonTypes["anyenum"] = 3500] = "anyenum";
    CommonTypes[CommonTypes["tsvector"] = 3614] = "tsvector";
    CommonTypes[CommonTypes["tsquery"] = 3615] = "tsquery";
    CommonTypes[CommonTypes["gtsvector"] = 3642] = "gtsvector";
    CommonTypes[CommonTypes["_tsvector"] = 3643] = "_tsvector";
    CommonTypes[CommonTypes["_gtsvector"] = 3644] = "_gtsvector";
    CommonTypes[CommonTypes["_tsquery"] = 3645] = "_tsquery";
    CommonTypes[CommonTypes["regconfig"] = 3734] = "regconfig";
    CommonTypes[CommonTypes["_regconfig"] = 3735] = "_regconfig";
    CommonTypes[CommonTypes["regdictionary"] = 3769] = "regdictionary";
    CommonTypes[CommonTypes["_regdictionary"] = 3770] = "_regdictionary";
    CommonTypes[CommonTypes["jsonb"] = 3802] = "jsonb";
    CommonTypes[CommonTypes["_jsonb"] = 3807] = "_jsonb";
    CommonTypes[CommonTypes["anyrange"] = 3831] = "anyrange";
    CommonTypes[CommonTypes["event_trigger"] = 3838] = "event_trigger";
    CommonTypes[CommonTypes["int4range"] = 3904] = "int4range";
    CommonTypes[CommonTypes["_int4range"] = 3905] = "_int4range";
    CommonTypes[CommonTypes["numrange"] = 3906] = "numrange";
    CommonTypes[CommonTypes["_numrange"] = 3907] = "_numrange";
    CommonTypes[CommonTypes["tsrange"] = 3908] = "tsrange";
    CommonTypes[CommonTypes["_tsrange"] = 3909] = "_tsrange";
    CommonTypes[CommonTypes["tstzrange"] = 3910] = "tstzrange";
    CommonTypes[CommonTypes["_tstzrange"] = 3911] = "_tstzrange";
    CommonTypes[CommonTypes["daterange"] = 3912] = "daterange";
    CommonTypes[CommonTypes["_daterange"] = 3913] = "_daterange";
    CommonTypes[CommonTypes["int8range"] = 3926] = "int8range";
    CommonTypes[CommonTypes["_int8range"] = 3927] = "_int8range";
    CommonTypes[CommonTypes["pg_shseclabel"] = 4066] = "pg_shseclabel";
    CommonTypes[CommonTypes["jsonpath"] = 4072] = "jsonpath";
    CommonTypes[CommonTypes["_jsonpath"] = 4073] = "_jsonpath";
})(CommonTypes || (exports.CommonTypes = CommonTypes = {}));
class PostgresError extends orm_1.DatabaseError {
}
exports.PostgresError = PostgresError;
class PostgresConnectionError extends PostgresError {
}
exports.PostgresConnectionError = PostgresConnectionError;
const postgresEpoch = 946684800000; //new Date('2000-01-01 00:00:00 UTC').getTime();
function readUint32BE(data, offset = 0) {
    return data[offset + 3] + (data[offset + 2] * 2 ** 8) + (data[offset + 1] * 2 ** 16) + (data[offset] * 2 ** 24);
}
function readInt32BE(data, offset = 0) {
    return (data[offset + 3] << 24) | (data[offset + 2] << 16) | (data[offset + 1] << 8) | data[offset];
}
function readUint16BE(data, offset = 0) {
    return data[offset + 1] + (data[offset] * 2 ** 8);
}
function readInt64BE(view, offset = 0) {
    return Number(view.getBigInt64(offset));
}
function parseText(description) {
    switch (description.type) {
        case CommonTypes.text:
        case CommonTypes.varchar:
        case CommonTypes.bpchar:
            return `decodeUTF8(data, offset + 4, offset + 4 + length)`;
    }
    return '';
}
// see https://doxygen.postgresql.org/backend_2utils_2adt_2numeric_8c_source.html
// see https://github.com/pgagarinov/libpqtypes/blob/master/source/src/numerics.c
function parseNumeric(view, data, offset, length) {
    // 1234.0000000012343434 => {digits: 5, weight: 0, scale: 16}
    //* 0.000012343434 => {digits: 2, weight: -2, scale: 12} => 1234_3434 / 10**(3*4)
    // 0.00001234 => {digits: 1, weight: -2, scale: 8}
    //* 0.001234 => {digits: 2, weight: -1, scale: 6} => 0012_3400 / 10**(2*4)
    // 0.0012343434 => {digits: 3, weight: -1, scale: 10}
    // 0.12343434 => {digits: 2, weight: -1, scale: 8}
    // 0.1234 => {digits: 1, weight: -1, scale: 4}
    // 1234 => {digits: 1, weight: 0, scale: 0}
    // 1234.12343434 => {digits: 3, weight: 0, scale: 8}
    // 1234.343 => {digits: 2, weight: 0, scale: 3}
    // 1234.3434 => {digits: 2, weight: 0, scale: 4}
    // 12343434 => {digits: 2, weight: 1, scale: 0}
    // 12343434.24 => {digits: 3, weight: 1, scale: 2}
    // how many pairs of 16bit digits are there
    const digits = view.getUint16(offset);
    const weight = view.getInt16(offset + 2);
    const sign = data[offset + 4] === 0 ? 1 : -1;
    // decimal point position from right
    const scale = view.getUint16(offset + 6);
    //digits left of the decimal point
    const digitsLeft = weight >= 0 ? weight + 1 : 0;
    //digits right of the decimal point
    const digitsRight = digits - digitsLeft;
    const digitsRightWeight = digits - (weight + 1);
    let value = 0;
    let weightOffset = offset + 8;
    let weightMultiplier = digitsLeft - 1;
    while (weightMultiplier >= 0) {
        const digit = view.getUint16(weightOffset);
        value += digit * (10000 ** weightMultiplier);
        weightOffset += 2;
        weightMultiplier--;
    }
    // for '0.001234' we have:
    // 001234 => 0012 3400 => 000c 2000
    // 123400 would be wrong, so we can not read from right to left
    weightOffset = offset + 8 + (digitsLeft * 2);
    weightMultiplier = digitsRight - 1;
    let fraction = 0;
    while (weightMultiplier >= 0) {
        const digit = view.getUint16(weightOffset);
        fraction += digit * (10000 ** weightMultiplier);
        weightOffset += 2;
        weightMultiplier--;
    }
    // console.log('parseNumeric', { digits, digitsLeft, digitsRight, digitsRightWeight, weight, sign, scale, value, fraction });
    return sign * (value + fraction / 10 ** (digitsRightWeight * 4));
}
function parseNumber(description) {
    switch (description.type) {
        case CommonTypes.int2:
            return `view.getInt16(offset + 4)`;
        case CommonTypes.int4:
            return `view.getInt32(offset + 4)`;
        case CommonTypes.int8:
            return `readInt64BE(view, offset + 4)`;
        case CommonTypes.float4:
            return `view.getFloat32(offset + 4)`;
        case CommonTypes.float8:
            return `view.getFloat64(offset + 4)`;
        case CommonTypes.numeric:
            return `parseNumeric(view, data, offset + 4, length)`;
        case CommonTypes.bool:
            return `data[offset + 4]`;
        case CommonTypes.time:
        case CommonTypes.timestamp:
        case CommonTypes.timestamptz:
            // microseconds
            return `(${postgresEpoch} + readInt64BE(view, offset + 4) / 1000)`;
        case CommonTypes.date:
            return `view.getInt32(offset + 4)`;
        case CommonTypes.interval:
            // 2x int64. first is seconds, second is number of months
            return `0`;
        case CommonTypes.money:
            return `readInt64BE(view, offset + 4) / 100`;
    }
    return '';
}
function getPropertyDeserializer(context, description, property) {
    if ((0, type_1.isBinary)(property.type)) {
        // todo handle typed arrays
        return `data.subarray(offset + 4, offset + 4 + length)`;
    }
    if ((0, type_1.isMapType)(property.type)) {
        // todo handle Map
        return `parseJson(decodeUTF8(data, offset + 4, offset + 4 + length))`;
    }
    if ((0, type_1.isSetType)(property.type)) {
        // todo handle Set
        return `parseJson(decodeUTF8(data, offset + 4, offset + 4 + length))`;
    }
    if ((0, type_1.isDateType)(property.type)) {
        const number = parseNumber(description);
        if (number) {
            if (description.type === CommonTypes.date)
                return `new Date(${postgresEpoch} + ${number} * 24 * 60 * 60 * 1000)`;
            return `new Date(${number})`;
        }
        const text = parseText(description);
        if (text)
            return `new Date(${text})`;
        return `new Date(0)`;
    }
    switch (property.type.kind) {
        case type_1.ReflectionKind.string: {
            const number = parseNumber(description);
            if (number)
                return `'' + ${number}`;
            const text = parseText(description);
            if (text)
                return text;
            return `''`;
        }
        case type_1.ReflectionKind.number: {
            const text = parseText(description);
            if (text)
                return `+${text}`;
            return parseNumber(description);
        }
        case type_1.ReflectionKind.boolean:
            if (description.type === CommonTypes.bool)
                return `data[offset + 4] === 1`;
            return parseNumber(description) + ' !== 0';
        case type_1.ReflectionKind.union: {
            // todo we need a type guard to check which type it is from the members
            // if its json/jsonb we just use regular deserialization of deepkit/type
            throw new Error('Unsupported property type ' + property.type);
            break;
        }
        case type_1.ReflectionKind.class:
        case type_1.ReflectionKind.array:
        case type_1.ReflectionKind.objectLiteral:
            return `parseJson(decodeUTF8(data, offset + 4 + 1, offset + 4 + length))`;
        default:
            throw new Error('Unsupported property type ' + property.type);
    }
}
function buildTypeDeserializer(description, type) {
    if (type.kind !== type_1.ReflectionKind.class && type.kind !== type_1.ReflectionKind.objectLiteral && type.kind !== type_1.ReflectionKind.tuple) {
        throw new Error('Invalid type for deserialization');
    }
    const isArray = type.kind === type_1.ReflectionKind.tuple;
    const context = new core_1.CompilerContext();
    const lines = [];
    const inlineProps = [];
    context.set({
        readInt64BE,
        DataView,
        decodeUTF8: core_1.decodeUTF8,
        readUint32BE,
        parseNumeric,
        parseJson: JSON.parse,
    });
    const v = context.reserveName('v');
    const properties = [];
    for (const member of type.types) {
        if ((0, type_1.isPropertyType)(member)) {
            properties.push([context.reserveVariable(), member]);
        }
        else if (member.kind === type_1.ReflectionKind.tupleMember) {
            properties.push([context.reserveVariable(), member]);
        }
    }
    // align properties array with description array.
    // latter defines the value order in binary response.
    const rootColumns = []; //columns that are in properties and description (and are not from an e.g. join)
    if (isArray) {
        for (let i = 0; i < description.length; i++) {
            const column = description[i];
            const property = properties[i];
            if (!property)
                continue;
            rootColumns.push([...property, column]);
        }
    }
    else {
        for (const column of description) {
            const property = properties.find(v => v[1].name === column.name);
            if (!property)
                continue;
            rootColumns.push([...property, column]);
        }
    }
    for (const [varName, property, description] of rootColumns) {
        lines.push(`
            length = readUint32BE(data, offset);
            ${varName} = ${getPropertyDeserializer(context, description, property)}
            offset += 4 + length;
        `);
        if (isArray) {
            inlineProps.push(varName);
        }
        else {
            inlineProps.push(`${String(property.name)}: ${varName}`);
        }
    }
    const createObject = isArray ? `[${inlineProps.join(', ')}]` : `{${inlineProps.join(', ')}}`;
    const code = `
    const view = new DataView(data.buffer, data.byteOffset, data.byteLength);
    let offset = 1 + 4 + 2; // Skip type, length, and field count
    let length = 0;

    ${lines.join('\n')}

    const ${v} = ${createObject};

    result.push(${v});
    `;
    // console.log(code);
    return context.build(code, 'data', 'result');
}
function buildDeserializer(description, selector) {
    const type = selector.schema.type;
    if (type.kind !== type_1.ReflectionKind.class && type.kind !== type_1.ReflectionKind.objectLiteral) {
        throw new Error('Invalid type for deserialization');
    }
    const context = new core_1.CompilerContext();
    const lines = [];
    const inlineProps = [];
    const assignProps = [];
    context.set({
        readInt64BE,
        DataView,
        decodeUTF8: core_1.decodeUTF8,
        readUint32BE,
        parseJson: JSON.parse,
    });
    const isClass = type.kind === type_1.ReflectionKind.class;
    const handledPropertiesInConstructor = [];
    const constructorArguments = [];
    const preLines = [];
    const postLines = [];
    const v = context.reserveName('v');
    const properties = type.types
        .filter(v => (0, type_1.isPropertyType)(v))
        .map(v => {
        return [context.reserveVariable(), v];
    });
    // align properties array with description array.
    // latter defines the value order in binary response.
    const rootColumns = []; //columns that are in properties and description (and are not from an e.g. join)
    for (const column of description) {
        const property = properties.find(v => v[1].name === column.name);
        if (!property)
            continue;
        rootColumns.push([...property, column]);
    }
    for (const [varName, property, description] of rootColumns) {
        if (!(0, type_1.isPropertyType)(property))
            continue;
        lines.push(`
            length = readUint32BE(data, offset);
            ${varName} = ${getPropertyDeserializer(context, description, property)}
            offset += 4 + length;
        `);
        if (isClass) {
            assignProps.push(`${v}.${(0, type_1.memberNameToString)(property.name)} = ${varName};`);
        }
        else {
            inlineProps.push(`${String(property.name)}: ${varName}`);
        }
    }
    let createObject = '';
    if (isClass) {
        const clazz = type_1.ReflectionClass.from(type.classType);
        const constructor = clazz.getConstructorOrUndefined();
        const classType = context.reserveConst(type.classType);
        if (!clazz.disableConstructor && constructor) {
            handledPropertiesInConstructor.push(...(0, type_1.getDeepConstructorProperties)(type).map(v => String(v.name)));
            const parameters = constructor.getParameters();
            for (const parameter of parameters) {
                if (!parameter.isProperty()) {
                    constructorArguments.push('undefined');
                    continue;
                }
                const property = clazz.getProperty(parameter.getName()).type;
                if (!property)
                    continue;
                //todo handle is skipped
                const entry = properties.find(v => v[1] === property);
                if (!entry)
                    continue;
                constructorArguments.push(entry[0]);
            }
        }
        if (clazz.disableConstructor) {
            createObject = `Object.create(${classType}.prototype);`;
            for (const property of clazz.getProperties()) {
                if (property.property.kind !== type_1.ReflectionKind.property || property.property.default === undefined)
                    continue;
                const defaultFn = context.reserveConst(property.property.default);
                createObject += `\n${v}.${(0, type_1.memberNameToString)(property.name)} = ${defaultFn}.apply(${v});`;
            }
        }
        else {
            createObject = `new ${classType}(${constructorArguments.join(', ')})`;
            // preLines.push(`const oldCheck = typeSettings.unpopulatedCheck; typeSettings.unpopulatedCheck = UnpopulatedCheck.None;`);
            // postLines.push(`typeSettings.unpopulatedCheck = oldCheck;`);
        }
    }
    else {
        createObject = `{${inlineProps.join(', ')}}`;
    }
    const code = `
    const view = new DataView(data.buffer, data.byteOffset, data.byteLength);
    let offset = 1 + 4 + 2; // Skip type, length, and field count
    let length = 0;

    ${lines.join('\n')}

    ${preLines.join('\n')}
    const ${v} = ${createObject};
    ${assignProps.join('\n')}
    ${postLines.join('\n')}

    result.push(${v});
    `;
    // console.log(code);
    return context.build(code, 'data', 'result');
}
function getStringBasedPropertyDeserializer(context, property, varName) {
    return '';
}
// simple query is text based encoding, so everything is a string.
function buildDeserializerForSimpleType(type) {
    if (type.kind !== type_1.ReflectionKind.class && type.kind !== type_1.ReflectionKind.objectLiteral) {
        throw new Error('Invalid type for deserialization');
    }
    const context = new core_1.CompilerContext();
    const lines = [];
    const props = [];
    context.set({
        DataView,
        decodeUTF8: core_1.decodeUTF8,
        readUint32BE,
        parseJson: JSON.parse,
    });
    for (const field of type.types) {
        if (!(0, type_1.isPropertyType)(field))
            continue;
        const varName = context.reserveVariable();
        lines.push(`
            length = readUint32BE(data, offset);
            ${getStringBasedPropertyDeserializer(context, field, varName)}
            offset += 4 + length;
        `);
        props.push(`${String(field.name)}: ${varName},`);
    }
    const code = `
    const view = new DataView(data.buffer, data.byteOffset, data.byteLength);
    let offset = 1 + 4 + 2; // Skip type, length, and field count
    let length = 0;
    ${lines.join('\n')}

    result.push({
        ${props.join('\n')}
    });
    `;
    return context.build(code, 'data', 'result');
}
function buildAutoIncrementDeserializer(type) {
    const schema = type_1.ReflectionClass.fromType(type);
    return buildDeserializerForSimpleType({
        kind: type_1.ReflectionKind.objectLiteral,
        types: [
            schema.getPrimary().property,
        ],
    });
}
function int32Buffer(value) {
    const buffer = Buffer.alloc(4);
    buffer.writeUint32BE(value);
    return buffer;
}
function int16Buffer(value) {
    const buffer = Buffer.alloc(2);
    buffer.writeUint16BE(value);
    return buffer;
}
function sendParse(statementName, query, paramTypeOids) {
    const nameBuffer = Buffer.from(statementName + '\0', 'utf8');
    const queryBuffer = Buffer.from(query + '\0', 'utf8');
    const typeCountBuffer = int16Buffer(paramTypeOids.length);
    const typesBuffer = Buffer.concat(paramTypeOids.map(oid => int32Buffer(oid)));
    const message = Buffer.concat([
        Buffer.from('P'), // Parse message
        Buffer.from([0, 0, 0, 1]),
        nameBuffer,
        queryBuffer,
        typeCountBuffer,
        typesBuffer,
    ]);
    message.writeUint32BE(message.length - 1, 1);
    return message;
}
function sendDescribe(statementName) {
    const message = Buffer.concat([
        Buffer.from('D'), // Describe message
        Buffer.from([0, 0, 0, 1]), // Length
        Buffer.from('S'), // Statement
        Buffer.from(statementName + '\0', 'utf8'),
    ]);
    message.writeUint32BE(message.length - 1, 1);
    return message;
}
function sendBind(portalName, statementName, parameters) {
    const portalBuffer = Buffer.from(portalName + '\0', 'utf8');
    const statementBuffer = Buffer.from(statementName + '\0', 'utf8');
    const paramCountBuffer = int16Buffer(parameters.length);
    const paramBuffers = Buffer.concat(parameters.map(param => {
        const paramBuffer = Buffer.from(param + '', 'utf8');
        const paramLengthBuffer = int32Buffer(paramBuffer.length);
        return Buffer.concat([paramLengthBuffer, paramBuffer]);
    }));
    const message = Buffer.concat([
        Buffer.from('B'), // Bind message
        Buffer.from([0, 0, 0, 1]),
        portalBuffer,
        statementBuffer,
        Buffer.from([0, 1, 0, 0]), // (1, 1) = (amount, text)
        // Buffer.from([0, 1, 0, 1]), // (1, 1) = (amount, binary), Int16 + (Int16[C])
        paramCountBuffer, //Int16
        paramBuffers, //(Int32, Bytes)[]
        Buffer.from([0, 1, 0, 1]), // Result column format codes (1, 1) = (amount, binary), Int16 + (Int16[C])
    ]);
    message.writeUint32BE(message.length - 1, 1);
    return message;
}
function getSimpleQueryBuffer(query) {
    const queryBuffer = Buffer.from(query + '\0', 'utf8');
    const message = Buffer.concat([
        Buffer.from('Q'), // Query message
        int32Buffer(queryBuffer.length + 4),
        queryBuffer,
    ]);
    return message;
}
function sendExecute(portalName, maxRows) {
    const portalBuffer = Buffer.from(portalName + '\0', 'utf8');
    const maxRowsBuffer = int32Buffer(maxRows);
    const message = Buffer.concat([
        Buffer.from('E'), // Execute message
        Buffer.from([0, 0, 0, 1]),
        portalBuffer,
        maxRowsBuffer,
    ]);
    message.writeUint32BE(message.length - 1, 1);
    return message;
}
const syncMessage = Buffer.from('S\0\0\0\x04');
function readMessageSize(buffer, offset = 0) {
    return 1 + (buffer[offset + 4] + (buffer[offset + 3] * 2 ** 8) + (buffer[offset + 2] * 2 ** 16) + (buffer[offset + 1] * 2 ** 24));
}
exports.readMessageSize = readMessageSize;
class ResponseParser {
    constructor(onMessage) {
        this.onMessage = onMessage;
        this.currentMessageSize = 0;
    }
    feed(data, bytes) {
        if (!data.byteLength)
            return;
        if (!bytes)
            bytes = data.byteLength;
        // console.log('got chunk', data.length);
        if (!this.currentMessage) {
            if (data.byteLength < 5) {
                //not enough data to read the header. Wait for next onData
                return;
            }
            this.currentMessage = data.byteLength === bytes ? data : data.subarray(0, bytes);
            this.currentMessageSize = readMessageSize(data);
        }
        else {
            this.currentMessage = Buffer.concat([this.currentMessage, data.byteLength === bytes ? data : data.subarray(0, bytes)]);
            if (!this.currentMessageSize) {
                if (this.currentMessage.byteLength < 5) {
                    //not enough data to read the header. Wait for next onData
                    return;
                }
                this.currentMessageSize = readMessageSize(this.currentMessage);
            }
        }
        let currentSize = this.currentMessageSize;
        let currentBuffer = this.currentMessage;
        while (currentBuffer) {
            if (currentSize > currentBuffer.byteLength) {
                //important to copy, since the incoming might change its data
                this.currentMessage = currentBuffer;
                // this.currentMessage = currentBuffer;
                this.currentMessageSize = currentSize;
                //message not completely loaded, wait for next onData
                return;
            }
            if (currentSize === currentBuffer.byteLength) {
                //current buffer is exactly the message length
                this.currentMessageSize = 0;
                this.currentMessage = undefined;
                this.onMessage(currentBuffer);
                return;
            }
            if (currentSize < currentBuffer.byteLength) {
                //we have more messages in this buffer. read what is necessary and hop to next loop iteration
                // const message = currentBuffer.subarray(0, currentSize);
                // co
                // nsole.log('onMessage', currentSize, message.length)
                this.onMessage(currentBuffer);
                currentBuffer = currentBuffer.subarray(currentSize);
                // currentBuffer = new Uint8Array(currentBuffer.buffer, currentBuffer.byteOffset + currentSize);
                if (currentBuffer.byteLength < 5) {
                    //not enough data to read the header. Wait for next onData
                    this.currentMessage = currentBuffer;
                    this.currentMessageSize = 0;
                    return;
                }
                const nextCurrentSize = readMessageSize(currentBuffer);
                if (nextCurrentSize <= 0)
                    throw new Error('message size wrong');
                currentSize = nextCurrentSize;
                //buffer and size has been set. consume this message in the next loop iteration
            }
        }
    }
}
exports.ResponseParser = ResponseParser;
var ConnectionStatus;
(function (ConnectionStatus) {
    ConnectionStatus["pending"] = "pending";
    ConnectionStatus["connecting"] = "connecting";
    ConnectionStatus["connected"] = "connected";
    ConnectionStatus["disconnected"] = "disconnected";
})(ConnectionStatus || (exports.ConnectionStatus = ConnectionStatus = {}));
class PostgresDatabaseTransaction extends orm_1.DatabaseTransaction {
    /**
     * This is the default for mysql databases.
     */
    repeatableRead() {
        this.setTransaction = 'REPEATABLE READ';
        return this;
    }
    readCommitted() {
        this.setTransaction = 'READ COMMITTED';
        return this;
    }
    serializable() {
        this.setTransaction = 'SERIALIZABLE';
        return this;
    }
    async begin() {
        if (!this.reservation)
            return;
        const set = this.setTransaction ? 'SET TRANSACTION ISOLATION LEVEL ' + this.setTransaction + ';' : '';
        // await this.connection.run(set + 'START TRANSACTION');
    }
    async commit() {
        if (!this.reservation)
            return;
        if (this.ended)
            throw new Error('Transaction ended already');
        // await this.connection.run('COMMIT');
        this.ended = true;
        this.reservation.release();
    }
    async rollback() {
        if (!this.reservation)
            return;
        if (this.ended)
            throw new Error('Transaction ended already');
        // await this.connection.run('ROLLBACK');
        this.ended = true;
        this.reservation.release();
    }
}
exports.PostgresDatabaseTransaction = PostgresDatabaseTransaction;
function noopDeserializer(message) {
}
class Command {
    constructor() {
        this.description = [];
        this.write = () => void 0;
    }
    sendAndWait(message, deserializer = noopDeserializer) {
        this.write(message);
        return (0, core_1.asyncOperation)((resolve, reject) => {
            const current = {
                resolve,
                reject,
                deserializer,
            };
            if (this.tail) {
                this.tail.next = current;
                this.tail = current;
            }
            else {
                this.head = current;
                this.tail = current;
            }
        });
    }
    next() {
        // todo: all of this is probably not correct, as it sometimes hangs,
        //  also it's not the fastest way to do it.
        if (this.head) {
            this.head = this.head.next;
            if (!this.head)
                this.tail = undefined;
        }
    }
    async query(sql, type = this.query.Ω?.[0]) {
        this.query.Ω = undefined;
        let deserializer = () => {
        };
        if (type) {
            type = (0, type_1.resolveReceiveType)(type);
            const jit = (0, type_1.getTypeJitContainer)(type);
            deserializer = jit.sqlQueryDeserializer;
            if (!deserializer) {
                deserializer = jit.sqlQueryDeserializer = buildDeserializerForSimpleType(type);
            }
        }
        const buffer = getSimpleQueryBuffer(sql);
        const rows = [];
        await this.sendAndWait(buffer, (buffer) => {
            deserializer(buffer, rows);
        });
        return rows[0];
    }
    needsWritableHost() {
        return false;
    }
    handleDescription(description) {
    }
    handleResponse(response) {
        // console.log(`Command handleResponse ${getClassName(this)} type ${String.fromCharCode(response[0])}`);
        switch (response[0]) {
            case 0x45: { // E
                const length = readUint32BE(response, 1);
                const error = (0, core_1.decodeUTF8)(response, 5, length);
                this.head.reject(error);
                break;
            }
            case 0x44: { // D
                this.head.deserializer(response);
                break;
            }
            case 0x54: { // T, RowDescription
                this.description = [];
                const columns = readUint16BE(response, 5);
                let offset = 1 + 4 + 2;
                for (let i = 0; i < columns; i++) {
                    const length = (0, core_1.findNullByte)(response, offset);
                    const columnName = (0, core_1.decodeUTF8)(response, offset, offset + length);
                    offset += length + 1;
                    const columnObjectId = readUint32BE(response, offset);
                    const columnAttributeNumber = readUint16BE(response, offset + 4);
                    const type = readUint32BE(response, offset + 6);
                    const typeSize = readUint16BE(response, offset + 10);
                    const typeModifier = readUint32BE(response, offset + 12);
                    const format = readUint16BE(response, offset + 16);
                    offset += 18;
                    const typeName = CommonTypes[type] || type.toString();
                    this.description.push({
                        name: columnName, typeName, type, typeSize,
                        columnObjectId, columnAttributeNumber, format, typeModifier,
                    });
                }
                this.handleDescription(this.description);
                break;
            }
            case 0x5A: { // Z
                this.head.resolve();
                return true;
            }
            default: {
                // console.log('unhandled', String.fromCharCode(response[0]), response);
            }
        }
        return false;
    }
}
exports.Command = Command;
Command.__type = ['T', 'sql', () => __ΩReceiveType, 'type', 'query', 'Command', 'b!""P&2"e"!o#"2$8"0%""""5w&'];
class SimpleQueryCommand extends Command {
    constructor(sql) {
        super();
        this.sql = sql;
        this.message = getSimpleQueryBuffer(sql);
    }
    async execute(host, connection, transaction) {
        await this.sendAndWait(this.message, (message) => {
        });
        return [];
    }
}
exports.SimpleQueryCommand = SimpleQueryCommand;
class InsertCommand extends Command {
    constructor(platform, prepared, items) {
        super();
        this.platform = platform;
        this.prepared = prepared;
        this.items = items;
    }
    async execute(host, client, transaction) {
        const names = [];
        const placeholder = new this.platform.placeholderStrategy;
        const scopeSerializer = (0, type_1.getSerializeFunction)(this.prepared.type, this.platform.serializer.serializeRegistry);
        for (const property of this.prepared.fields) {
            if (property.autoIncrement)
                continue;
            names.push(property.columnNameEscaped);
        }
        const placeholders = [];
        const params = [];
        for (const item of this.items) {
            const converted = scopeSerializer(item);
            const values = [];
            for (const property of this.prepared.fields) {
                if (property.autoIncrement)
                    continue;
                values.push(placeholder.getPlaceholder());
                params.push(converted[property.name]);
            }
            placeholders.push(values.join(', '));
        }
        const returning = this.prepared.primaryKey.autoIncrement ? 'RETURNING ' + this.prepared.primaryKey.columnNameEscaped : '';
        const sql = `INSERT INTO ${this.prepared.tableNameEscaped} (${names.join(', ')})
                VALUES (${placeholders.join('), (')}) ${returning}`;
        const statement = '';
        const message = Buffer.concat([
            sendParse(statement, sql, []),
            sendBind('', statement, params),
            sendExecute('', 0),
            syncMessage,
        ]);
        // console.log('insert', sql);
        const deserializerAutoIncrement = buildAutoIncrementDeserializer(this.prepared.type);
        const rows = [];
        await this.sendAndWait(message, (v) => deserializerAutoIncrement(v, rows));
        // console.log('rows', rows);
        for (let i = 0; i < this.items.length; i++) {
            if (!rows[i])
                break;
            this.items[i][this.prepared.primaryKey.name] = rows[i][this.prepared.primaryKey.name];
        }
        // parse data rows: auto-incremented columns
        return 0;
    }
}
exports.InsertCommand = InsertCommand;
/**
 * This command just exists for us to debug the binary responses.
 */
class DebugSelectCommand extends Command {
    constructor(sql, type) {
        super();
        this.sql = sql;
        this.type = type;
    }
    handleDescription(description) {
        this.deserialize = buildTypeDeserializer(description, this.type);
    }
    async execute(host, connection, transaction) {
        const result = { rows: [], columns: [], types: [], values: [] };
        // Query, Parse, Bind, Describe, Execute, Sync
        const message = Buffer.concat([
            sendParse('', this.sql, []),
            sendBind('', '', []),
            sendDescribe(''),
            sendExecute('', 0),
            syncMessage,
        ]);
        await this.sendAndWait(message, (response) => {
            switch (response[0]) {
                case 0x31: { // 1, ParseComplete
                    break;
                }
                case 0x32: { // 2, BindComplete
                    break;
                }
                case 0x43: { // C, CommandComplete
                    break;
                }
                case 0x54: { // T, RowDescription
                    const columns = readUint16BE(response, 5);
                    let offset = 1 + 4 + 2;
                    for (let i = 0; i < columns; i++) {
                        const length = (0, core_1.findNullByte)(response, offset);
                        const columnName = (0, core_1.decodeUTF8)(response, offset, offset + length);
                        offset += length + 1;
                        const columnObjectId = readUint32BE(response, offset);
                        const columnAttributeNumber = readUint16BE(response, offset + 4);
                        const type = readUint32BE(response, offset + 6);
                        const typeSize = readUint16BE(response, offset + 10);
                        const typeModifier = readUint32BE(response, offset + 12);
                        const format = readUint16BE(response, offset + 16);
                        offset += 18;
                        const typeName = CommonTypes[type] || type.toString();
                        result.types.push(typeName);
                        result.columns.push({
                            name: columnName, type, typeName, typeSize,
                            columnObjectId, columnAttributeNumber, format, typeModifier,
                        });
                    }
                    this.handleDescription(result.columns);
                    break;
                }
                case 0x74: { // t, ParameterDescription
                    const parameters = readUint16BE(response, 5);
                    let offset = 1 + 4 + 2;
                    for (let i = 0; i < parameters; i++) {
                        const objectID = readUint32BE(response, offset);
                        offset += 4;
                    }
                    break;
                }
                case 0x45: { // E, Error
                    const length = readUint32BE(response, 1);
                    const error = (0, core_1.decodeUTF8)(response, 5, length);
                    this.head.reject(error);
                    break;
                }
                case 0x44: { // D
                    const columns = readUint16BE(response, 5);
                    let offset = 1 + 4 + 2;
                    for (let i = 0; i < columns; i++) {
                        const length = readUint32BE(response, offset);
                        result.rows.push(Buffer.from(response).toString('hex', offset + 4, offset + 4 + length));
                        offset += 4 + length;
                    }
                    this.deserialize(response, result.values);
                    break;
                }
                case 0x5A: { // Z
                    this.head.resolve();
                    break;
                }
                default: {
                    console.log(`unhandled ${String.fromCharCode(response[0])}`);
                    break;
                }
            }
        });
        return result;
    }
    handleResponse(response) {
        try {
            this.head.deserializer(response);
        }
        catch (e) {
            this.head.reject(e);
        }
        return response[0] === 0x5A;
    }
}
exports.DebugSelectCommand = DebugSelectCommand;
class FindCommand extends Command {
    constructor(sql, selector, statementName = '') {
        super();
        this.sql = sql;
        this.selector = selector;
        this.statementName = statementName;
        this.created = false;
        console.log('new FindCommand', sql);
    }
    setParameters(params) {
        if (!params.length)
            return;
        this.cache = Buffer.concat([
            sendBind('', this.statementName, params),
            sendExecute('', 0),
            syncMessage,
        ]);
    }
    handleDescription(description) {
        if (this.deserialize)
            return;
        //todo: we need to make sure DescibeColumn is completely defined
        // like for unknown types like enums we have to use TypeResolver,
        // or not? What is the concrete use-case example?
        const serializer = this.selector.select.length === 0;
        this.deserialize = serializer
            ? buildDeserializer(description, this.selector)
            : () => {
                //todo more complex deserializer
            };
    }
    async execute(host, connection, transaction) {
        if (!this.created) {
            this.write(Buffer.concat([
                sendParse(this.statementName, this.sql, []),
                sendDescribe(this.statementName),
            ]));
            this.created = true;
        }
        if (!this.cache) {
            this.cache = Buffer.concat([
                sendBind('', this.statementName, this.selector.params),
                sendExecute('', 0),
                syncMessage,
            ]);
        }
        const rows = [];
        await this.sendAndWait(this.cache, (data) => {
            // try {
            //     this.deserialize!(data, rows);
            // } catch (e) {
            //     console.log('deserialize error', e);
            //     throw e;
            // }
        });
        return rows;
    }
}
exports.FindCommand = FindCommand;
class SelectCommand extends Command {
    constructor(sql, type) {
        super();
        this.sql = sql;
        this.type = type;
    }
    async execute(host, connection, transaction) {
        const res = await this.query(this.sql, this.type);
        return true;
    }
}
class HandshakeCommand extends Command {
    async execute(host, connection, transaction) {
        this.host = host;
        const parameters = 'user\0postgres\0database\0postgres\0\0';
        const protocolVersion = Buffer.from([0x00, 0x03, 0x00, 0x00]); // Version 3.0
        const totalLength = Buffer.alloc(4);
        totalLength.writeInt32BE(Buffer.byteLength(parameters) + protocolVersion.length + 4);
        const startupMessage = Buffer.concat([totalLength, protocolVersion, Buffer.from(parameters)]);
        await this.sendAndWait(startupMessage);
        return true;
    }
    handleResponse(response) {
        switch (response[0]) {
            case 0x53: { // S
                if (!this.host)
                    break;
                const length = readUint32BE(response, 1);
                const firstNull = response.indexOf(0, 5);
                const name = (0, core_1.decodeUTF8)(response, 5, firstNull);
                const value = (0, core_1.decodeUTF8)(response, firstNull + 1, length);
                this.host.parameters[name] = value;
                if (name === 'in_hot_standby' && value === 'on') {
                    this.host.setType(1 /* HostType.secondary */);
                }
                break;
            }
        }
        return super.handleResponse(response);
    }
}
class PostgresStats {
    constructor() {
        /**
         * How many connections have been created.
         */
        this.connectionsCreated = 0;
        /**
         * How many connections have been reused.
         */
        this.connectionsReused = 0;
        /**
         * How many connection requests were queued because pool was full.
         */
        this.connectionsQueued = 0;
        this.bytesReceived = 0;
        this.bytesSent = 0;
    }
}
exports.PostgresStats = PostgresStats;
class PostgresConnectionPool {
    constructor(config, stats) {
        this.config = config;
        this.stats = stats;
        this.connectionId = 0;
        /**
         * Connections, might be in any state, not necessarily connected.
         */
        this.connections = [];
        this.hints = {};
        this.queue = [];
        this.releaseReservation = this.releaseReservation.bind(this);
    }
    async waitForAllConnectionsToConnect(throws = false) {
        const promises = [];
        for (const connection of this.connections) {
            if (connection.connectingPromise) {
                promises.push(connection.connectingPromise);
            }
        }
        if (!promises.length)
            return;
        // try {
        if (throws) {
            await Promise.all(promises);
        }
        else {
            await Promise.allSettled(promises);
        }
        // } catch (error: any) {
        //     throw new PostgresConnectionError(`Failed to connect: ${formatError(error)}`, { cause: error });
        // }
    }
    async connect() {
        await this.ensureHostsConnected(true);
    }
    close() {
        //import to work on the copy, since Connection.onClose modifies this.connections.
        const connections = this.connections.slice(0);
        for (const connection of connections) {
            connection.close();
        }
    }
    async ensureHostsConnected(throws = false) {
        if (this.ensureHostsConnectedPromise)
            return this.ensureHostsConnectedPromise;
        //make sure each host has at least one connection
        const hosts = await this.config.getHosts();
        for (const host of hosts) {
            if (host.connections.length > 0)
                continue;
            this.newConnection(host);
        }
        return this.ensureHostsConnectedPromise = (0, core_1.asyncOperation)(async (resolve) => {
            await this.waitForAllConnectionsToConnect(throws);
            resolve(undefined);
        }).then(() => {
            this.ensureHostsConnectedPromise = undefined;
        });
    }
    findHostForRequest(hosts, request) {
        //todo, handle request.nearest
        for (const host of hosts) {
            if (!request.readonly && host.isWritable())
                return host;
            if (request.readonly && host.isReadable())
                return host;
        }
        throw new PostgresConnectionError(`Could not find host for connection request. (readonly=${request.readonly}, hosts=${hosts.length}). Last Error: ${this.lastError}`);
    }
    createAdditionalConnectionForRequest(request) {
        const hosts = this.config.hosts;
        const host = this.findHostForRequest(hosts, request);
        return this.newConnection(host);
    }
    newConnection(host) {
        this.stats.connectionsCreated++;
        const connection = new PostgresClientConnection(this.connectionId++, host, this.config, (connection) => {
            (0, core_1.arrayRemoveItem)(host.connections, connection);
            (0, core_1.arrayRemoveItem)(this.connections, connection);
            //onClose does not automatically reconnect. Only new commands re-establish connections.
        }, (bytesSent) => {
            this.stats.bytesSent += bytesSent;
        }, (bytesReceived) => {
            this.stats.bytesReceived += bytesReceived;
        });
        host.connections.push(connection);
        this.connections.push(connection);
        return connection;
    }
    matchRequest(connection, request) {
        if (!request.readonly)
            return connection.host.isWritable();
        return connection.host.isReadable();
    }
    isConnectionUsable(connection) {
        return connection.isConnected() && connection.exclusives === 0 && connection.users < this.config.options.maxUsersPerConnection;
    }
    /**
     * Returns an existing or new connection, that needs to be released once done using it.
     */
    async getConnection(request = {}) {
        // if (request.hint) {
        //     const connection = this.hints[request.hint];
        //     if (connection && this.isConnectionUsable(connection) && this.matchRequest(connection, request)) {
        //         this.stats.connectionsReused++;
        //         connection.users++;
        //         if (request.exclusive) connection.exclusives++;
        //
        //         if (connection.cleanupTimeout) {
        //             clearTimeout(connection.cleanupTimeout);
        //             connection.cleanupTimeout = undefined;
        //         }
        //
        //         return connection;
        //     }
        // }
        await this.ensureHostsConnected(true);
        let candidate;
        for (const connection of this.connections) {
            if (!this.isConnectionUsable(connection))
                continue;
            if (!this.matchRequest(connection, request))
                continue;
            if (candidate && connection.users < candidate.users) {
                candidate = connection;
            }
            else {
                candidate = connection;
            }
        }
        if (candidate) {
            this.stats.connectionsReused++;
            candidate.users++;
            if (request.exclusive)
                candidate.exclusives++;
            if (candidate.cleanupTimeout) {
                clearTimeout(candidate.cleanupTimeout);
                candidate.cleanupTimeout = undefined;
            }
            if (request.hint)
                this.hints[request.hint] = candidate;
            return candidate;
        }
        if (this.connections.length < this.config.options.maxPoolSize) {
            const connection = this.createAdditionalConnectionForRequest(request);
            connection.users++;
            if (request.exclusive)
                connection.exclusives++;
            if (request.hint)
                this.hints[request.hint] = connection;
            return connection;
        }
        return (0, core_1.asyncOperation)((resolve) => {
            this.stats.connectionsQueued++;
            this.queue.push({
                resolve: (connection) => {
                    if (request.hint)
                        this.hints[request.hint] = connection;
                    resolve(connection);
                }, request,
            });
        });
    }
    release(connection) {
        for (let i = 0; i < this.queue.length; i++) {
            const waiter = this.queue[i];
            if (!this.isConnectionUsable(connection) || !this.matchRequest(connection, waiter.request))
                continue;
            connection.users++;
            if (waiter.request.exclusive)
                connection.exclusives++;
            this.stats.connectionsReused++;
            this.queue.splice(i, 1);
            waiter.resolve(connection);
            //we don't set reserved/set cleanupTimeout,
            //since the connection is already reserved and the timeout
            //is only set when the connection actually is starting idling.
            return;
        }
        if (connection.users === 0) {
            connection.cleanupTimeout = setTimeout(() => {
                if (this.connections.length <= this.config.options.minPoolSize) {
                    return;
                }
                connection.close();
            }, this.config.options.maxIdleTimeMS);
        }
    }
    releaseReservation(connection, exclusive) {
        connection.users--;
        if (exclusive) {
            connection.exclusives--;
        }
        // connections attached to a transaction are not automatically released.
        // only with commit/rollback actions
        if (connection.transaction && !connection.transaction.ended)
            return;
        if (connection.transaction)
            connection.transaction = undefined;
        this.release(connection);
    }
    async reserve(request = {}) {
        const existing = request.transaction?.reservation;
        if (existing) {
            existing.connection.users++;
            if (request.exclusive)
                existing.connection.exclusives++;
            return new ConnectionReservation(existing.connection, this.releaseReservation, !!request.exclusive);
        }
        const connection = await this.getConnection(request);
        const reservation = new ConnectionReservation(connection, this.releaseReservation, !!request.exclusive);
        //todo check if this is correct and align with mongo
        if (request.transaction) {
            request.transaction.reservation = reservation;
            connection.transaction = request.transaction;
            try {
                await request.transaction.begin();
            }
            catch (error) {
                request.transaction.ended = true;
                reservation.release();
                throw new Error('Could not start transaction: ' + error);
            }
        }
        return reservation;
    }
}
exports.PostgresConnectionPool = PostgresConnectionPool;
class ConnectionReservation {
    constructor(connection, onRelease, exclusive) {
        this.connection = connection;
        this.onRelease = onRelease;
        this.exclusive = exclusive;
        this.released = false;
    }
    release() {
        if (this.released)
            return;
        this.released = true;
        // do not set reserved here, since the pool manager will do that.
        this.onRelease(this.connection, this.exclusive);
    }
}
exports.ConnectionReservation = ConnectionReservation;
/**
 * Service to resolve type information for unknown types like enums.
 */
class TypeResolver {
    constructor() {
        this.TTL = 60 * 5; // 5 minutes
        this.cache = {};
    }
    async resolveType(connection, oid) {
        const rows = await connection.run(`SELECT oid, typname, typcategory FROM pg_type WHERE oid = ${oid}`);
        if (rows.length === 0)
            throw new Error(`Could not resolve type for oid ${oid}`);
        const row = rows[0];
        console.log('rows', rows);
        return { oid: row.oid, name: row.typname, type: row.typcategory };
    }
    async getType(connection, oid) {
        const cached = this.cache[oid];
        if (cached && Date.now() - cached.time < this.TTL) {
            return cached.type;
        }
        const type = await this.resolveType(connection, oid);
        this.cache[oid] = { type, time: Date.now() };
        return type;
    }
}
exports.TypeResolver = TypeResolver;
/**
 * @reflection never
 */
class PostgresClientConnection {
    constructor(id, host, config, onClose, onSent, onReceived) {
        this.id = id;
        this.host = host;
        this.config = config;
        this.onClose = onClose;
        this.onSent = onSent;
        this.onReceived = onReceived;
        this.messageId = 0;
        this.typeResolver = new TypeResolver();
        this.status = ConnectionStatus.pending;
        this.bufferSize = 2.5 * 1024 * 1024;
        this.cache = {};
        this.activeCommands = 0;
        this.executedCommands = 0;
        /**
         * How many users are currently using this connection, including exclusive users.
         */
        this.users = 0;
        /**
         * How many exclusive users are currently using this connection.
         */
        this.exclusives = 0;
        this.bytesReceived = 0;
        this.bytesSent = 0;
        this.boundWrite = this.write.bind(this);
        console.log('newConnection', id);
        this.responseParser = new ResponseParser(this.onResponse.bind(this));
        if (this.config.options.ssl === true) {
            const options = {
                host: host.hostname,
                port: host.port,
                timeout: config.options.connectTimeoutMS,
                servername: host.hostname,
            };
            const optional = {
                ca: config.options.tlsCAFile,
                key: config.options.tlsCertificateKeyFile || config.options.tlsCertificateFile,
                cert: config.options.tlsCertificateFile,
                passphrase: config.options.tlsCertificateKeyFilePassword,
                rejectUnauthorized: config.options.rejectUnauthorized,
                crl: config.options.tlsCRLFile,
                checkServerIdentity: config.options.checkServerIdentity ? undefined : () => undefined,
            };
            for (const i in optional) {
                if (optional[i])
                    options[i] = optional[i];
            }
            this.socket = (0, tls_1.connect)(options);
            this.socket.on('data', (data) => {
                this.bytesReceived += data.byteLength;
                this.onReceived(data.byteLength);
                this.responseParser.feed(data);
            });
        }
        else {
            this.socket = (0, net_1.createConnection)({
                host: host.hostname,
                port: host.port,
                timeout: config.options.connectTimeoutMS,
            });
            this.socket.on('data', (data) => {
                this.bytesReceived += data.byteLength;
                this.onReceived(data.byteLength);
                this.responseParser.feed(data);
            });
            // this.socket.setNoDelay(true);
            // const socket = this.socket = turbo.connect(host.port, host.hostname);
            // // this.socket.setNoDelay(true);
            // const buffer = Buffer.allocUnsafe(this.bufferSize);
            //
            // function read() {
            //     socket.read(buffer, onRead);
            // }
            //
            // function onRead(err: any, buf: Buffer, bytes: number) {
            //     if (!bytes) return;
            //     responseParser.feed(buf, bytes);
            //     read();
            // }
            //
            // read();
        }
        //important to catch it, so it doesn't bubble up
        this.connect().catch((error) => {
            this.error = error;
            this.socket.end();
            onClose(this);
        });
    }
    getCache(key) {
        return this.cache[key];
    }
    setCache(key, command) {
        this.cache[key] = command;
    }
    isConnected() {
        return this.status === ConnectionStatus.connected;
    }
    isConnecting() {
        return this.status === ConnectionStatus.connecting;
    }
    close() {
        this.status = ConnectionStatus.disconnected;
        this.socket.end();
    }
    run(sql) {
        return this.execute(new SelectCommand(sql));
    }
    query(sql, params) {
        //todo this is not possible since we don't know the parameters types
    }
    /**
     * When a full message from the server was received.
     */
    onResponse(message) {
        if (!this.commandHead)
            throw new PostgresError(`Got a server response without active command`);
        if (this.commandHead.command.handleResponse(message)) {
            this.commandHead = this.commandHead.next;
            if (!this.commandHead) {
                this.commandTail = undefined;
            }
            const command = this.commandHead?.command;
            if (command) {
                command.next();
            }
        }
    }
    /**
     * Puts a command on the queue and executes it when queue is empty.
     * A promise is return that is resolved when executed successfully, or rejected
     * when timed out, parser error, or any other error.
     */
    async execute(command) {
        // console.log('execute', this.id, this.status, this.lastCommand, getClassName(command));
        if (this.status === ConnectionStatus.pending)
            await this.connect();
        if (this.status === ConnectionStatus.disconnected)
            throw new PostgresError('Disconnected');
        if (this.status === ConnectionStatus.connecting && !(command instanceof HandshakeCommand)) {
            await this.connectingPromise;
        }
        const next = { command };
        if (this.commandTail) {
            this.commandTail.next = next;
            this.commandTail = next;
        }
        else {
            this.commandHead = next;
            this.commandTail = next;
        }
        this.activeCommands++;
        this.executedCommands++;
        command.write = this.boundWrite;
        try {
            return await command.execute(this.host, this, this.transaction);
        }
        finally {
            this.activeCommands--;
        }
    }
    write(message) {
        this.socket.write(message);
        this.bytesSent += message.byteLength;
        this.onSent(message.byteLength);
    }
    async connect() {
        if (this.status === ConnectionStatus.disconnected)
            throw new PostgresConnectionError('Connection disconnected');
        if (this.status !== ConnectionStatus.pending)
            return;
        this.status = ConnectionStatus.connecting;
        this.connectingPromise = (0, core_1.asyncOperation)(async (resolve, reject) => {
            this.socket.once('close', (hadErrors) => {
                this.onClose(this);
                if (this.status !== ConnectionStatus.connecting)
                    return;
                this.status = ConnectionStatus.disconnected;
                reject(new PostgresConnectionError('Connection closed while connecting'));
            });
            this.socket.once('lookup', (error) => {
                if (this.status !== ConnectionStatus.connecting)
                    return;
                if (error) {
                    this.connectingPromise = undefined;
                    this.status = ConnectionStatus.disconnected;
                    reject(new PostgresConnectionError((0, core_1.formatError)(error), { cause: error }));
                }
            });
            this.socket.once('error', (error) => {
                if (this.status !== ConnectionStatus.connecting)
                    return;
                this.connectingPromise = undefined;
                this.status = ConnectionStatus.disconnected;
                reject(new PostgresConnectionError((0, core_1.formatError)(error), { cause: error }));
            });
            if (this.socket.destroyed) {
                console.log(this.id, 'destroyed');
                this.status = ConnectionStatus.disconnected;
                this.connectingPromise = undefined;
                resolve();
            }
            this.socket.once('ready', async () => {
                try {
                    if (await this.execute(new HandshakeCommand())) {
                        this.status = ConnectionStatus.connected;
                        this.socket.setTimeout(this.config.options.socketTimeoutMS);
                        this.connectingPromise = undefined;
                        resolve();
                    }
                    else {
                        this.status = ConnectionStatus.disconnected;
                        this.connectingPromise = undefined;
                        reject(new PostgresConnectionError('Connection error: Could not complete handshake 🤷‍️'));
                    }
                }
                catch (error) {
                    this.status = ConnectionStatus.disconnected;
                    this.connectingPromise = undefined;
                    reject(new PostgresConnectionError('Connection error: ' + (0, core_1.formatError)(error), { cause: error }));
                }
            });
        });
        return this.connectingPromise;
    }
}
exports.PostgresClientConnection = PostgresClientConnection;
class PostgresClient {
    constructor(options) {
        this.stats = new PostgresStats();
        this.config = 'string' === typeof options ? new config_js_1.PostgresClientConfig(options) : options;
        this.pool = new PostgresConnectionPool(this.config, this.stats);
    }
    async reserve(request = {}) {
        return this.pool.reserve(request);
    }
    async query(sql) {
        return await this.execute(new SimpleQueryCommand(sql));
    }
    async execute(command) {
        const reservation = await this.reserve();
        try {
            return await reservation.connection.execute(command);
        }
        finally {
            reservation.release();
        }
    }
    close() {
        this.pool.close();
    }
}
exports.PostgresClient = PostgresClient;
//# sourceMappingURL=client.js.map